using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

using Emgu.CV;
using Emgu.CV.Structure;
using Emgu.CV.UI;
using Emgu.CV.GPU;

namespace TestProject
{
    /// <summary>
    /// α׷
    /// </summary>
    static class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region α׷ ϱ - Main()

        /// <summary>
        /// α׷ ϱ
        /// </summary>
        [STAThread]
        private static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            Image<Bgr, Byte> image = new Image<Bgr, byte>("sample.jpg");

            long detectionTime;

            List<Rectangle> faceRectangleList = new List<Rectangle>();
            List<Rectangle> eyeRectangleList  = new List<Rectangle>();

            FaceDetectionHelper.Detect
            (
                image,
                "haarcascade_frontalface_default.xml",
                "haarcascade_eye.xml",
                faceRectangleList,
                eyeRectangleList,
                out detectionTime
            );

            foreach(Rectangle faceRectangle in faceRectangleList)
            {
                image.Draw(faceRectangle, new Bgr(Color.Red), 1);
            }

            foreach(Rectangle eyeRectangle in eyeRectangleList)
            {
                image.Draw(eyeRectangle, new Bgr(Color.Blue), 2);
            }

            ImageViewer.Show
            (
                image,
                string.Format
                (
                    "{0}  /  Ϸ : {1} и",
                    GpuInvoke.HasCuda ? "GPU" : "CPU",
                    detectionTime
                )
            );
        }

        #endregion
    }
}